\\ Copyright 2017, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
default(strictargs,1);
read("alternate-defines.gp");

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

check_exact(TriangleVertices(4), 5+4+3+2+1);
check_exact(TriangleVertices(5), 6+5+4+3+2+1);


\\        len=4                               len=6
\\  5                     * n=5      5                     * n=5       
\\                        |                           g=4  |           
\\  4                 *---*          4                 *-@-*           
\\               g=3  |   |                            |   |           
\\  3             *-@-*---*          3             *---*-@-*           
\\                |   |   |                        |   |   |           
\\  2         *---*-@-*---*          2         *---*---*-@-*           
\\            |   |   |   |                    |   |   |   |           
\\  1     *---*---*-@-*---*          1     *---*---*---*-@-*           
\\        |   |   |   |   |                |   |   |   @   |           
\\  0 *---*---*---*-@-*---*          0 *---*---*---*-@-*---*           
\\    0   1   2   3=x 4   5            0   1   2   3=x 4   5            

\\        len=6                            len=6                  
\\  5                     * n=5      5                     * n=5  
\\                   g=4  |                           g=4  |      
\\  4                 *---*          4                 *---*      
\\                    |   |                            @   @      
\\  3             *---*---*          3             *---*---*      
\\                @   @   @                        |   |   |      
\\  2         *-@-*---*---*          2         *---*---*---*      
\\            |   |   |   |                    |   |   |   |      
\\  1     *---*-@-*---*---*          1     *-@-*---*---*---*      
\\        |   |   |   |   |                |   |   |   |   |      
\\  0 *---*---*-@-*---*---*          0 *---*-@-*---*---*---*      
\\    0   1   2=x 3   4   5            0   1=x 2   3   4   5      

\\ x_to_diagonal_max(x,len)
\\ {
\\   if(len<x+1,0,
\\      len==x+1,TriangleVertices(x),
\\      TriangleVertices(g) - (g-x));
\\ }
\\ check_exact(x_to_diagonal_max(0,0), 1, "xd 0,0");
\\ check_exact(x_to_diagonal_max(3,1), 4+3);
\\ check_exact(x_to_diagonal_max(2,4), 3 + 4+3+2+1);
\\ check_exact(x_to_diagonal_max(5,5), TriangleVertices(5));


caps=List([]);
{
  for(n=0,15,
     my(whole=TriangleVertices(n),
        half=floor(whole/2),
        min_c=1e100,
        min_p,
        min_cap,
        l);
     for(x=0,n-1,
        my(len=x+1);
        my(p=TriangleVertices(x),
           pmax=min(p,half));
        my(c=len/pmax);
        if(c<min_c,min_c=c;l=List([]));
        if(c==min_c,
           listput(l,[x,len,pmax,if(pmax<p,"cap","")]);
           min_cap=pmax<p);

        my(len=2*(x+1));
        my(p=2*TriangleVertices(x),
           pmax=min(p,half));
        my(c=len/pmax);
        if(c<min_c,min_c=c;l=List([]));
        if(c==min_c,
           listput(l,[x,len,pmax,if(pmax<p,"cap",pmax==p,"exact",""),"corner"]);
           min_cap=pmax<p);

        \\ if(p>half,break());
        );
     print(min_c" "l"  half="half"  "min_c*1.0);
     listput(caps,min_cap);
  );
}
Vec(caps)


\\ [0,0,0,1,0,0,1,1,0,1,1,0,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,0,1,1,0,1,1,0,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,0,1,0,0,1,1,0,0,1,0,0,1,1,0]
