#!/usr/bin/perl -w

# Copyright 2019, 2020 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use List::Util 'min';
use Math::BaseCnv;
use Math::BigInt;

use FindBin;
use lib $FindBin::Bin;
use MyAlternate '@Dean_state_table',
  '@Dean_LtoH_state_table','@Dean_LtoH_state_to_symbol',
  '@Dean_LtoH_state_to_name';
use MyPrintwrap ':all';
use MyFLAT;
$|=1;


print "% generated by tools/$FindBin::Script\n";

foreach my $state (0 .. $#Dean_LtoH_state_table) {
  print "% GP-DEFINE  Dean_LtoH_$Dean_LtoH_state_to_name[$state] = ",
    $state+1, ";\n";
}

printwrap_indent("% GP-DEFINE  ");
printwrap("Dean_state_table = ");
printwrap_gp_matrix([map{ [map {$_+1} @$_] } @Dean_state_table],
                    "Dean_state_table");

printwrap("Dean_LtoH_state_table = ");
printwrap_gp_matrix([map{ [map {$_+1} @$_] } @Dean_LtoH_state_table],
                    "Dean_LtoH_state_table");

printwrap_gp_vector(\@Dean_LtoH_state_to_symbol,
                    "Dean_LtoH_state_to_symbol");

print "% end generated\n";
exit 0;
